/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) for deployed graph details.
    /// </summary>
    [DataContract(Name = "DeployedGraphDto")]
    public partial class DeployedGraphDto : IEquatable<DeployedGraphDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DeployedGraphDto" /> class.
        /// </summary>
        /// <param name="uri">Graph URI and identifier..</param>
        /// <param name="fileHashes">Collection of file hashes associated with the graph..</param>
        public DeployedGraphDto(string uri = default(string), List<string> fileHashes = default(List<string>))
        {
            this.Uri = uri;
            this.FileHashes = fileHashes;
        }

        /// <summary>
        /// Graph URI and identifier.
        /// </summary>
        /// <value>Graph URI and identifier.</value>
        [DataMember(Name = "uri", EmitDefaultValue = false)]
        public string Uri { get; set; }

        /// <summary>
        /// Collection of file hashes associated with the graph.
        /// </summary>
        /// <value>Collection of file hashes associated with the graph.</value>
        [DataMember(Name = "fileHashes", EmitDefaultValue = false)]
        public List<string> FileHashes { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class DeployedGraphDto {\n");
            sb.Append("  Uri: ").Append(Uri).Append("\n");
            sb.Append("  FileHashes: ").Append(FileHashes).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DeployedGraphDto);
        }

        /// <summary>
        /// Returns true if DeployedGraphDto instances are equal
        /// </summary>
        /// <param name="input">Instance of DeployedGraphDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DeployedGraphDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Uri == input.Uri ||
                    (this.Uri != null &&
                    this.Uri.Equals(input.Uri))
                ) && 
                (
                    this.FileHashes == input.FileHashes ||
                    this.FileHashes != null &&
                    input.FileHashes != null &&
                    this.FileHashes.SequenceEqual(input.FileHashes)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Uri != null)
                {
                    hashCode = (hashCode * 59) + this.Uri.GetHashCode();
                }
                if (this.FileHashes != null)
                {
                    hashCode = (hashCode * 59) + this.FileHashes.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
