/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing the creation of a metadata tree.  Extends the base class Coscine.Api.Core.Shared.DataTransferObjects.ParameterObjects.MetadataTreeForManipulationDto.
    /// </summary>
    [DataContract(Name = "ExtractedMetadataTreeForCreationDto")]
    public partial class ExtractedMetadataTreeForCreationDto : IEquatable<ExtractedMetadataTreeForCreationDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ExtractedMetadataTreeForCreationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ExtractedMetadataTreeForCreationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ExtractedMetadataTreeForCreationDto" /> class.
        /// </summary>
        /// <param name="path">Gets or initializes the path of the metadata tree. (required).</param>
        /// <param name="id">Gets or sets the id of the new metadata tree. (required).</param>
        /// <param name="definition">definition (required).</param>
        /// <param name="provenance">provenance (required).</param>
        public ExtractedMetadataTreeForCreationDto(string path = default(string), string id = default(string), RdfDefinitionForManipulationDto definition = default(RdfDefinitionForManipulationDto), ProvenanceParametersDto provenance = default(ProvenanceParametersDto))
        {
            // to ensure "path" is required (not null)
            if (path == null)
            {
                throw new ArgumentNullException("path is a required property for ExtractedMetadataTreeForCreationDto and cannot be null");
            }
            this.Path = path;
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new ArgumentNullException("id is a required property for ExtractedMetadataTreeForCreationDto and cannot be null");
            }
            this.Id = id;
            // to ensure "definition" is required (not null)
            if (definition == null)
            {
                throw new ArgumentNullException("definition is a required property for ExtractedMetadataTreeForCreationDto and cannot be null");
            }
            this.Definition = definition;
            // to ensure "provenance" is required (not null)
            if (provenance == null)
            {
                throw new ArgumentNullException("provenance is a required property for ExtractedMetadataTreeForCreationDto and cannot be null");
            }
            this.Provenance = provenance;
        }

        /// <summary>
        /// Gets or initializes the path of the metadata tree.
        /// </summary>
        /// <value>Gets or initializes the path of the metadata tree.</value>
        [DataMember(Name = "path", IsRequired = true, EmitDefaultValue = true)]
        public string Path { get; set; }

        /// <summary>
        /// Gets or sets the id of the new metadata tree.
        /// </summary>
        /// <value>Gets or sets the id of the new metadata tree.</value>
        [DataMember(Name = "id", IsRequired = true, EmitDefaultValue = true)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets Definition
        /// </summary>
        [DataMember(Name = "definition", IsRequired = true, EmitDefaultValue = true)]
        public RdfDefinitionForManipulationDto Definition { get; set; }

        /// <summary>
        /// Gets or Sets Provenance
        /// </summary>
        [DataMember(Name = "provenance", IsRequired = true, EmitDefaultValue = true)]
        public ProvenanceParametersDto Provenance { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ExtractedMetadataTreeForCreationDto {\n");
            sb.Append("  Path: ").Append(Path).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Definition: ").Append(Definition).Append("\n");
            sb.Append("  Provenance: ").Append(Provenance).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ExtractedMetadataTreeForCreationDto);
        }

        /// <summary>
        /// Returns true if ExtractedMetadataTreeForCreationDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ExtractedMetadataTreeForCreationDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ExtractedMetadataTreeForCreationDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Path == input.Path ||
                    (this.Path != null &&
                    this.Path.Equals(input.Path))
                ) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Definition == input.Definition ||
                    (this.Definition != null &&
                    this.Definition.Equals(input.Definition))
                ) && 
                (
                    this.Provenance == input.Provenance ||
                    (this.Provenance != null &&
                    this.Provenance.Equals(input.Provenance))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Path != null)
                {
                    hashCode = (hashCode * 59) + this.Path.GetHashCode();
                }
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.Definition != null)
                {
                    hashCode = (hashCode * 59) + this.Definition.GetHashCode();
                }
                if (this.Provenance != null)
                {
                    hashCode = (hashCode * 59) + this.Provenance.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Path (string) minLength
            if (this.Path != null && this.Path.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Path, length must be greater than 1.", new [] { "Path" });
            }

            yield break;
        }
    }

}
