/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) for GitLab options.
    /// </summary>
    [DataContract(Name = "GitLabOptionsDto")]
    public partial class GitLabOptionsDto : IEquatable<GitLabOptionsDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GitLabOptionsDto" /> class.
        /// </summary>
        /// <param name="projectId">The project ID associated with GitLab..</param>
        /// <param name="repoUrl">The repository URL for GitLab..</param>
        /// <param name="accessToken">The access token for GitLab..</param>
        /// <param name="branch">The branch for GitLab..</param>
        public GitLabOptionsDto(int projectId = default(int), string repoUrl = default(string), string accessToken = default(string), string branch = default(string))
        {
            this.ProjectId = projectId;
            this.RepoUrl = repoUrl;
            this.AccessToken = accessToken;
            this.Branch = branch;
        }

        /// <summary>
        /// The project ID associated with GitLab.
        /// </summary>
        /// <value>The project ID associated with GitLab.</value>
        [DataMember(Name = "projectId", EmitDefaultValue = false)]
        public int ProjectId { get; set; }

        /// <summary>
        /// The repository URL for GitLab.
        /// </summary>
        /// <value>The repository URL for GitLab.</value>
        [DataMember(Name = "repoUrl", EmitDefaultValue = true)]
        public string RepoUrl { get; set; }

        /// <summary>
        /// The access token for GitLab.
        /// </summary>
        /// <value>The access token for GitLab.</value>
        [DataMember(Name = "accessToken", EmitDefaultValue = true)]
        public string AccessToken { get; set; }

        /// <summary>
        /// The branch for GitLab.
        /// </summary>
        /// <value>The branch for GitLab.</value>
        [DataMember(Name = "branch", EmitDefaultValue = true)]
        public string Branch { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class GitLabOptionsDto {\n");
            sb.Append("  ProjectId: ").Append(ProjectId).Append("\n");
            sb.Append("  RepoUrl: ").Append(RepoUrl).Append("\n");
            sb.Append("  AccessToken: ").Append(AccessToken).Append("\n");
            sb.Append("  Branch: ").Append(Branch).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as GitLabOptionsDto);
        }

        /// <summary>
        /// Returns true if GitLabOptionsDto instances are equal
        /// </summary>
        /// <param name="input">Instance of GitLabOptionsDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(GitLabOptionsDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.ProjectId == input.ProjectId ||
                    this.ProjectId.Equals(input.ProjectId)
                ) && 
                (
                    this.RepoUrl == input.RepoUrl ||
                    (this.RepoUrl != null &&
                    this.RepoUrl.Equals(input.RepoUrl))
                ) && 
                (
                    this.AccessToken == input.AccessToken ||
                    (this.AccessToken != null &&
                    this.AccessToken.Equals(input.AccessToken))
                ) && 
                (
                    this.Branch == input.Branch ||
                    (this.Branch != null &&
                    this.Branch.Equals(input.Branch))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                hashCode = (hashCode * 59) + this.ProjectId.GetHashCode();
                if (this.RepoUrl != null)
                {
                    hashCode = (hashCode * 59) + this.RepoUrl.GetHashCode();
                }
                if (this.AccessToken != null)
                {
                    hashCode = (hashCode * 59) + this.AccessToken.GetHashCode();
                }
                if (this.Branch != null)
                {
                    hashCode = (hashCode * 59) + this.Branch.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
