/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing Hash Parameters in a request.
    /// </summary>
    [DataContract(Name = "HashParametersDto")]
    public partial class HashParametersDto : IEquatable<HashParametersDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="HashParametersDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected HashParametersDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="HashParametersDto" /> class.
        /// </summary>
        /// <param name="algorithmName">Gets or initializes the hash algorithm name. (required).</param>
        /// <param name="value">Gets or initializes the hash value. (required).</param>
        public HashParametersDto(string algorithmName = default(string), string value = default(string))
        {
            // to ensure "algorithmName" is required (not null)
            if (algorithmName == null)
            {
                throw new ArgumentNullException("algorithmName is a required property for HashParametersDto and cannot be null");
            }
            this.AlgorithmName = algorithmName;
            // to ensure "value" is required (not null)
            if (value == null)
            {
                throw new ArgumentNullException("value is a required property for HashParametersDto and cannot be null");
            }
            this.Value = value;
        }

        /// <summary>
        /// Gets or initializes the hash algorithm name.
        /// </summary>
        /// <value>Gets or initializes the hash algorithm name.</value>
        [DataMember(Name = "algorithmName", IsRequired = true, EmitDefaultValue = true)]
        public string AlgorithmName { get; set; }

        /// <summary>
        /// Gets or initializes the hash value.
        /// </summary>
        /// <value>Gets or initializes the hash value.</value>
        [DataMember(Name = "value", IsRequired = true, EmitDefaultValue = true)]
        public string Value { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class HashParametersDto {\n");
            sb.Append("  AlgorithmName: ").Append(AlgorithmName).Append("\n");
            sb.Append("  Value: ").Append(Value).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as HashParametersDto);
        }

        /// <summary>
        /// Returns true if HashParametersDto instances are equal
        /// </summary>
        /// <param name="input">Instance of HashParametersDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(HashParametersDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.AlgorithmName == input.AlgorithmName ||
                    (this.AlgorithmName != null &&
                    this.AlgorithmName.Equals(input.AlgorithmName))
                ) && 
                (
                    this.Value == input.Value ||
                    (this.Value != null &&
                    this.Value.Equals(input.Value))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AlgorithmName != null)
                {
                    hashCode = (hashCode * 59) + this.AlgorithmName.GetHashCode();
                }
                if (this.Value != null)
                {
                    hashCode = (hashCode * 59) + this.Value.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // AlgorithmName (string) minLength
            if (this.AlgorithmName != null && this.AlgorithmName.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for AlgorithmName, length must be greater than 1.", new [] { "AlgorithmName" });
            }

            // Value (string) minLength
            if (this.Value != null && this.Value.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Value, length must be greater than 1.", new [] { "Value" });
            }

            yield break;
        }
    }

}
