/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a data transfer object (DTO) for extracted metadata within a tree structure, extending the base TreeDto.
    /// </summary>
    [DataContract(Name = "MetadataTreeExtractedDto")]
    public partial class MetadataTreeExtractedDto : IEquatable<MetadataTreeExtractedDto>, IValidatableObject
    {

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", EmitDefaultValue = false)]
        public TreeDataType? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="MetadataTreeExtractedDto" /> class.
        /// </summary>
        /// <param name="path">The path of the tree item..</param>
        /// <param name="type">type.</param>
        /// <param name="metadataId">Gets the identifier of the metadata extraction graph..</param>
        /// <param name="rawDataId">Gets the identifier of the raw data extraction graph..</param>
        /// <param name="definition">definition.</param>
        public MetadataTreeExtractedDto(string path = default(string), TreeDataType? type = default(TreeDataType?), string metadataId = default(string), string rawDataId = default(string), RdfDefinitionDto definition = default(RdfDefinitionDto))
        {
            this.Path = path;
            this.Type = type;
            this.MetadataId = metadataId;
            this.RawDataId = rawDataId;
            this.Definition = definition;
        }

        /// <summary>
        /// The path of the tree item.
        /// </summary>
        /// <value>The path of the tree item.</value>
        [DataMember(Name = "path", EmitDefaultValue = false)]
        public string Path { get; set; }

        /// <summary>
        /// Gets the identifier of the metadata extraction graph.
        /// </summary>
        /// <value>Gets the identifier of the metadata extraction graph.</value>
        [DataMember(Name = "metadataId", EmitDefaultValue = false)]
        public string MetadataId { get; set; }

        /// <summary>
        /// Gets the identifier of the raw data extraction graph.
        /// </summary>
        /// <value>Gets the identifier of the raw data extraction graph.</value>
        [DataMember(Name = "rawDataId", EmitDefaultValue = true)]
        public string RawDataId { get; set; }

        /// <summary>
        /// Gets or Sets Definition
        /// </summary>
        [DataMember(Name = "definition", EmitDefaultValue = false)]
        public RdfDefinitionDto Definition { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class MetadataTreeExtractedDto {\n");
            sb.Append("  Path: ").Append(Path).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  MetadataId: ").Append(MetadataId).Append("\n");
            sb.Append("  RawDataId: ").Append(RawDataId).Append("\n");
            sb.Append("  Definition: ").Append(Definition).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as MetadataTreeExtractedDto);
        }

        /// <summary>
        /// Returns true if MetadataTreeExtractedDto instances are equal
        /// </summary>
        /// <param name="input">Instance of MetadataTreeExtractedDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(MetadataTreeExtractedDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Path == input.Path ||
                    (this.Path != null &&
                    this.Path.Equals(input.Path))
                ) && 
                (
                    this.Type == input.Type ||
                    this.Type.Equals(input.Type)
                ) && 
                (
                    this.MetadataId == input.MetadataId ||
                    (this.MetadataId != null &&
                    this.MetadataId.Equals(input.MetadataId))
                ) && 
                (
                    this.RawDataId == input.RawDataId ||
                    (this.RawDataId != null &&
                    this.RawDataId.Equals(input.RawDataId))
                ) && 
                (
                    this.Definition == input.Definition ||
                    (this.Definition != null &&
                    this.Definition.Equals(input.Definition))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Path != null)
                {
                    hashCode = (hashCode * 59) + this.Path.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.Type.GetHashCode();
                if (this.MetadataId != null)
                {
                    hashCode = (hashCode * 59) + this.MetadataId.GetHashCode();
                }
                if (this.RawDataId != null)
                {
                    hashCode = (hashCode * 59) + this.RawDataId.GetHashCode();
                }
                if (this.Definition != null)
                {
                    hashCode = (hashCode * 59) + this.Definition.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
