/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a data transfer object (DTO) for a PID (Persistent Identifier).
    /// </summary>
    [DataContract(Name = "PidDto")]
    public partial class PidDto : IEquatable<PidDto>, IValidatableObject
    {

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", EmitDefaultValue = false)]
        public PidType? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="PidDto" /> class.
        /// </summary>
        /// <param name="prefix">Gets or sets the prefix of the PID..</param>
        /// <param name="suffix">Gets or sets the suffix of the PID..</param>
        /// <param name="type">type.</param>
        /// <param name="isEntityValid">Gets or sets a value indicating whether the linked entity is considered valid..</param>
        public PidDto(string prefix = default(string), string suffix = default(string), PidType? type = default(PidType?), bool isEntityValid = default(bool))
        {
            this.Prefix = prefix;
            this.Suffix = suffix;
            this.Type = type;
            this.IsEntityValid = isEntityValid;
        }

        /// <summary>
        /// Gets or sets the prefix of the PID.
        /// </summary>
        /// <value>Gets or sets the prefix of the PID.</value>
        [DataMember(Name = "prefix", EmitDefaultValue = false)]
        public string Prefix { get; set; }

        /// <summary>
        /// Gets or sets the suffix of the PID.
        /// </summary>
        /// <value>Gets or sets the suffix of the PID.</value>
        [DataMember(Name = "suffix", EmitDefaultValue = false)]
        public string Suffix { get; set; }

        /// <summary>
        /// Gets the constructed PID by combining the prefix and suffix (\&quot;{Prefix}/{Suffix}\&quot;).
        /// </summary>
        /// <value>Gets the constructed PID by combining the prefix and suffix (\&quot;{Prefix}/{Suffix}\&quot;).</value>
        [DataMember(Name = "identifier", EmitDefaultValue = false)]
        public string Identifier { get; private set; }

        /// <summary>
        /// Returns false as Identifier should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeIdentifier()
        {
            return false;
        }
        /// <summary>
        /// Gets or sets a value indicating whether the linked entity is considered valid.
        /// </summary>
        /// <value>Gets or sets a value indicating whether the linked entity is considered valid.</value>
        [DataMember(Name = "isEntityValid", EmitDefaultValue = true)]
        public bool IsEntityValid { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class PidDto {\n");
            sb.Append("  Prefix: ").Append(Prefix).Append("\n");
            sb.Append("  Suffix: ").Append(Suffix).Append("\n");
            sb.Append("  Identifier: ").Append(Identifier).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  IsEntityValid: ").Append(IsEntityValid).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as PidDto);
        }

        /// <summary>
        /// Returns true if PidDto instances are equal
        /// </summary>
        /// <param name="input">Instance of PidDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PidDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Prefix == input.Prefix ||
                    (this.Prefix != null &&
                    this.Prefix.Equals(input.Prefix))
                ) && 
                (
                    this.Suffix == input.Suffix ||
                    (this.Suffix != null &&
                    this.Suffix.Equals(input.Suffix))
                ) && 
                (
                    this.Identifier == input.Identifier ||
                    (this.Identifier != null &&
                    this.Identifier.Equals(input.Identifier))
                ) && 
                (
                    this.Type == input.Type ||
                    this.Type.Equals(input.Type)
                ) && 
                (
                    this.IsEntityValid == input.IsEntityValid ||
                    this.IsEntityValid.Equals(input.IsEntityValid)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Prefix != null)
                {
                    hashCode = (hashCode * 59) + this.Prefix.GetHashCode();
                }
                if (this.Suffix != null)
                {
                    hashCode = (hashCode * 59) + this.Suffix.GetHashCode();
                }
                if (this.Identifier != null)
                {
                    hashCode = (hashCode * 59) + this.Identifier.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.Type.GetHashCode();
                hashCode = (hashCode * 59) + this.IsEntityValid.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
