/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing the creation of a project.  Inherits from the base class Coscine.Api.Core.Shared.DataTransferObjects.ParameterObjects.ProjectForManipulationDto.
    /// </summary>
    [DataContract(Name = "ProjectForCreationDto")]
    public partial class ProjectForCreationDto : IEquatable<ProjectForCreationDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectForCreationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectForCreationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectForCreationDto" /> class.
        /// </summary>
        /// <param name="name">Gets or initializes the name of the project. (required).</param>
        /// <param name="description">Gets or initializes the description of the project. (required).</param>
        /// <param name="startDate">Gets or initializes the start date of the project..</param>
        /// <param name="endDate">Gets or initializes the end date of the project..</param>
        /// <param name="keywords">Gets or initializes the keywords associated with the project..</param>
        /// <param name="displayName">Gets or initializes the display name of the project..</param>
        /// <param name="principleInvestigators">Gets or initializes the principal investigators associated with the project..</param>
        /// <param name="grantId">Gets or initializes the grant ID associated with the project..</param>
        /// <param name="visibility">visibility (required).</param>
        /// <param name="disciplines">Gets or initializes the disciplines associated with the project. (required).</param>
        /// <param name="organizations">Gets or initializes the organizations associated with the project. (required).</param>
        /// <param name="parentId">Gets or initializes the identifier of the parent project..</param>
        public ProjectForCreationDto(string name = default(string), string description = default(string), DateTime startDate = default(DateTime), DateTime endDate = default(DateTime), List<string> keywords = default(List<string>), string displayName = default(string), string principleInvestigators = default(string), string grantId = default(string), VisibilityForProjectManipulationDto visibility = default(VisibilityForProjectManipulationDto), List<DisciplineForProjectManipulationDto> disciplines = default(List<DisciplineForProjectManipulationDto>), List<OrganizationForProjectManipulationDto> organizations = default(List<OrganizationForProjectManipulationDto>), Guid? parentId = default(Guid?))
        {
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new ArgumentNullException("name is a required property for ProjectForCreationDto and cannot be null");
            }
            this.Name = name;
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new ArgumentNullException("description is a required property for ProjectForCreationDto and cannot be null");
            }
            this.Description = description;
            // to ensure "visibility" is required (not null)
            if (visibility == null)
            {
                throw new ArgumentNullException("visibility is a required property for ProjectForCreationDto and cannot be null");
            }
            this.Visibility = visibility;
            // to ensure "disciplines" is required (not null)
            if (disciplines == null)
            {
                throw new ArgumentNullException("disciplines is a required property for ProjectForCreationDto and cannot be null");
            }
            this.Disciplines = disciplines;
            // to ensure "organizations" is required (not null)
            if (organizations == null)
            {
                throw new ArgumentNullException("organizations is a required property for ProjectForCreationDto and cannot be null");
            }
            this.Organizations = organizations;
            this.StartDate = startDate;
            this.EndDate = endDate;
            this.Keywords = keywords;
            this.DisplayName = displayName;
            this.PrincipleInvestigators = principleInvestigators;
            this.GrantId = grantId;
            this.ParentId = parentId;
        }

        /// <summary>
        /// Gets or initializes the name of the project.
        /// </summary>
        /// <value>Gets or initializes the name of the project.</value>
        [DataMember(Name = "name", IsRequired = true, EmitDefaultValue = true)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or initializes the description of the project.
        /// </summary>
        /// <value>Gets or initializes the description of the project.</value>
        [DataMember(Name = "description", IsRequired = true, EmitDefaultValue = true)]
        public string Description { get; set; }

        /// <summary>
        /// Gets or initializes the start date of the project.
        /// </summary>
        /// <value>Gets or initializes the start date of the project.</value>
        [DataMember(Name = "startDate", EmitDefaultValue = false)]
        public DateTime StartDate { get; set; }

        /// <summary>
        /// Gets or initializes the end date of the project.
        /// </summary>
        /// <value>Gets or initializes the end date of the project.</value>
        [DataMember(Name = "endDate", EmitDefaultValue = false)]
        public DateTime EndDate { get; set; }

        /// <summary>
        /// Gets or initializes the keywords associated with the project.
        /// </summary>
        /// <value>Gets or initializes the keywords associated with the project.</value>
        [DataMember(Name = "keywords", EmitDefaultValue = true)]
        public List<string> Keywords { get; set; }

        /// <summary>
        /// Gets or initializes the display name of the project.
        /// </summary>
        /// <value>Gets or initializes the display name of the project.</value>
        [DataMember(Name = "displayName", EmitDefaultValue = true)]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or initializes the principal investigators associated with the project.
        /// </summary>
        /// <value>Gets or initializes the principal investigators associated with the project.</value>
        [DataMember(Name = "principleInvestigators", EmitDefaultValue = true)]
        public string PrincipleInvestigators { get; set; }

        /// <summary>
        /// Gets or initializes the grant ID associated with the project.
        /// </summary>
        /// <value>Gets or initializes the grant ID associated with the project.</value>
        [DataMember(Name = "grantId", EmitDefaultValue = true)]
        public string GrantId { get; set; }

        /// <summary>
        /// Gets or Sets Visibility
        /// </summary>
        [DataMember(Name = "visibility", IsRequired = true, EmitDefaultValue = true)]
        public VisibilityForProjectManipulationDto Visibility { get; set; }

        /// <summary>
        /// Gets or initializes the disciplines associated with the project.
        /// </summary>
        /// <value>Gets or initializes the disciplines associated with the project.</value>
        [DataMember(Name = "disciplines", IsRequired = true, EmitDefaultValue = true)]
        public List<DisciplineForProjectManipulationDto> Disciplines { get; set; }

        /// <summary>
        /// Gets or initializes the organizations associated with the project.
        /// </summary>
        /// <value>Gets or initializes the organizations associated with the project.</value>
        [DataMember(Name = "organizations", IsRequired = true, EmitDefaultValue = true)]
        public List<OrganizationForProjectManipulationDto> Organizations { get; set; }

        /// <summary>
        /// Gets or initializes the identifier of the parent project.
        /// </summary>
        /// <value>Gets or initializes the identifier of the parent project.</value>
        [DataMember(Name = "parentId", EmitDefaultValue = true)]
        public Guid? ParentId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProjectForCreationDto {\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  StartDate: ").Append(StartDate).Append("\n");
            sb.Append("  EndDate: ").Append(EndDate).Append("\n");
            sb.Append("  Keywords: ").Append(Keywords).Append("\n");
            sb.Append("  DisplayName: ").Append(DisplayName).Append("\n");
            sb.Append("  PrincipleInvestigators: ").Append(PrincipleInvestigators).Append("\n");
            sb.Append("  GrantId: ").Append(GrantId).Append("\n");
            sb.Append("  Visibility: ").Append(Visibility).Append("\n");
            sb.Append("  Disciplines: ").Append(Disciplines).Append("\n");
            sb.Append("  Organizations: ").Append(Organizations).Append("\n");
            sb.Append("  ParentId: ").Append(ParentId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectForCreationDto);
        }

        /// <summary>
        /// Returns true if ProjectForCreationDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectForCreationDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectForCreationDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.StartDate == input.StartDate ||
                    (this.StartDate != null &&
                    this.StartDate.Equals(input.StartDate))
                ) && 
                (
                    this.EndDate == input.EndDate ||
                    (this.EndDate != null &&
                    this.EndDate.Equals(input.EndDate))
                ) && 
                (
                    this.Keywords == input.Keywords ||
                    this.Keywords != null &&
                    input.Keywords != null &&
                    this.Keywords.SequenceEqual(input.Keywords)
                ) && 
                (
                    this.DisplayName == input.DisplayName ||
                    (this.DisplayName != null &&
                    this.DisplayName.Equals(input.DisplayName))
                ) && 
                (
                    this.PrincipleInvestigators == input.PrincipleInvestigators ||
                    (this.PrincipleInvestigators != null &&
                    this.PrincipleInvestigators.Equals(input.PrincipleInvestigators))
                ) && 
                (
                    this.GrantId == input.GrantId ||
                    (this.GrantId != null &&
                    this.GrantId.Equals(input.GrantId))
                ) && 
                (
                    this.Visibility == input.Visibility ||
                    (this.Visibility != null &&
                    this.Visibility.Equals(input.Visibility))
                ) && 
                (
                    this.Disciplines == input.Disciplines ||
                    this.Disciplines != null &&
                    input.Disciplines != null &&
                    this.Disciplines.SequenceEqual(input.Disciplines)
                ) && 
                (
                    this.Organizations == input.Organizations ||
                    this.Organizations != null &&
                    input.Organizations != null &&
                    this.Organizations.SequenceEqual(input.Organizations)
                ) && 
                (
                    this.ParentId == input.ParentId ||
                    (this.ParentId != null &&
                    this.ParentId.Equals(input.ParentId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Name != null)
                {
                    hashCode = (hashCode * 59) + this.Name.GetHashCode();
                }
                if (this.Description != null)
                {
                    hashCode = (hashCode * 59) + this.Description.GetHashCode();
                }
                if (this.StartDate != null)
                {
                    hashCode = (hashCode * 59) + this.StartDate.GetHashCode();
                }
                if (this.EndDate != null)
                {
                    hashCode = (hashCode * 59) + this.EndDate.GetHashCode();
                }
                if (this.Keywords != null)
                {
                    hashCode = (hashCode * 59) + this.Keywords.GetHashCode();
                }
                if (this.DisplayName != null)
                {
                    hashCode = (hashCode * 59) + this.DisplayName.GetHashCode();
                }
                if (this.PrincipleInvestigators != null)
                {
                    hashCode = (hashCode * 59) + this.PrincipleInvestigators.GetHashCode();
                }
                if (this.GrantId != null)
                {
                    hashCode = (hashCode * 59) + this.GrantId.GetHashCode();
                }
                if (this.Visibility != null)
                {
                    hashCode = (hashCode * 59) + this.Visibility.GetHashCode();
                }
                if (this.Disciplines != null)
                {
                    hashCode = (hashCode * 59) + this.Disciplines.GetHashCode();
                }
                if (this.Organizations != null)
                {
                    hashCode = (hashCode * 59) + this.Organizations.GetHashCode();
                }
                if (this.ParentId != null)
                {
                    hashCode = (hashCode * 59) + this.ParentId.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Name (string) maxLength
            if (this.Name != null && this.Name.Length > 200)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Name, length must be less than 200.", new [] { "Name" });
            }

            // Name (string) minLength
            if (this.Name != null && this.Name.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Name, length must be greater than 1.", new [] { "Name" });
            }

            // Description (string) maxLength
            if (this.Description != null && this.Description.Length > 10000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Description, length must be less than 10000.", new [] { "Description" });
            }

            // Description (string) minLength
            if (this.Description != null && this.Description.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Description, length must be greater than 1.", new [] { "Description" });
            }

            // DisplayName (string) maxLength
            if (this.DisplayName != null && this.DisplayName.Length > 25)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DisplayName, length must be less than 25.", new [] { "DisplayName" });
            }

            // PrincipleInvestigators (string) maxLength
            if (this.PrincipleInvestigators != null && this.PrincipleInvestigators.Length > 500)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PrincipleInvestigators, length must be less than 500.", new [] { "PrincipleInvestigators" });
            }

            // GrantId (string) maxLength
            if (this.GrantId != null && this.GrantId.Length > 500)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for GrantId, length must be less than 500.", new [] { "GrantId" });
            }

            yield break;
        }
    }

}
