/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a data transfer object (DTO) for provenance information.
    /// </summary>
    [DataContract(Name = "ProvenanceDto")]
    public partial class ProvenanceDto : IEquatable<ProvenanceDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProvenanceDto" /> class.
        /// </summary>
        /// <param name="id">Gets or sets the id of the current metadata graph..</param>
        /// <param name="generatedAt">Gets or sets the date and time when the metadata was generated..</param>
        /// <param name="wasRevisionOf">Gets or sets the adapted versions from the specific metadata tree..</param>
        /// <param name="variants">Gets or sets the variants of the specific metadata tree..</param>
        /// <param name="similarityToLastVersion">The similarity to the last version..</param>
        /// <param name="wasInvalidatedBy">Information if the specific metadata tree was invalidated by something..</param>
        /// <param name="hashParameters">hashParameters.</param>
        public ProvenanceDto(string id = default(string), DateTime? generatedAt = default(DateTime?), List<string> wasRevisionOf = default(List<string>), List<VariantDto> variants = default(List<VariantDto>), double? similarityToLastVersion = default(double?), string wasInvalidatedBy = default(string), HashParametersDto hashParameters = default(HashParametersDto))
        {
            this.Id = id;
            this.GeneratedAt = generatedAt;
            this.WasRevisionOf = wasRevisionOf;
            this.Variants = variants;
            this.SimilarityToLastVersion = similarityToLastVersion;
            this.WasInvalidatedBy = wasInvalidatedBy;
            this.HashParameters = hashParameters;
        }

        /// <summary>
        /// Gets or sets the id of the current metadata graph.
        /// </summary>
        /// <value>Gets or sets the id of the current metadata graph.</value>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the date and time when the metadata was generated.
        /// </summary>
        /// <value>Gets or sets the date and time when the metadata was generated.</value>
        [DataMember(Name = "generatedAt", EmitDefaultValue = true)]
        public DateTime? GeneratedAt { get; set; }

        /// <summary>
        /// Gets or sets the adapted versions from the specific metadata tree.
        /// </summary>
        /// <value>Gets or sets the adapted versions from the specific metadata tree.</value>
        [DataMember(Name = "wasRevisionOf", EmitDefaultValue = false)]
        public List<string> WasRevisionOf { get; set; }

        /// <summary>
        /// Gets or sets the variants of the specific metadata tree.
        /// </summary>
        /// <value>Gets or sets the variants of the specific metadata tree.</value>
        [DataMember(Name = "variants", EmitDefaultValue = false)]
        public List<VariantDto> Variants { get; set; }

        /// <summary>
        /// The similarity to the last version.
        /// </summary>
        /// <value>The similarity to the last version.</value>
        [DataMember(Name = "similarityToLastVersion", EmitDefaultValue = true)]
        public double? SimilarityToLastVersion { get; set; }

        /// <summary>
        /// Information if the specific metadata tree was invalidated by something.
        /// </summary>
        /// <value>Information if the specific metadata tree was invalidated by something.</value>
        [DataMember(Name = "wasInvalidatedBy", EmitDefaultValue = true)]
        public string WasInvalidatedBy { get; set; }

        /// <summary>
        /// Gets or Sets HashParameters
        /// </summary>
        [DataMember(Name = "hashParameters", EmitDefaultValue = false)]
        public HashParametersDto HashParameters { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProvenanceDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  GeneratedAt: ").Append(GeneratedAt).Append("\n");
            sb.Append("  WasRevisionOf: ").Append(WasRevisionOf).Append("\n");
            sb.Append("  Variants: ").Append(Variants).Append("\n");
            sb.Append("  SimilarityToLastVersion: ").Append(SimilarityToLastVersion).Append("\n");
            sb.Append("  WasInvalidatedBy: ").Append(WasInvalidatedBy).Append("\n");
            sb.Append("  HashParameters: ").Append(HashParameters).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProvenanceDto);
        }

        /// <summary>
        /// Returns true if ProvenanceDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ProvenanceDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProvenanceDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.GeneratedAt == input.GeneratedAt ||
                    (this.GeneratedAt != null &&
                    this.GeneratedAt.Equals(input.GeneratedAt))
                ) && 
                (
                    this.WasRevisionOf == input.WasRevisionOf ||
                    this.WasRevisionOf != null &&
                    input.WasRevisionOf != null &&
                    this.WasRevisionOf.SequenceEqual(input.WasRevisionOf)
                ) && 
                (
                    this.Variants == input.Variants ||
                    this.Variants != null &&
                    input.Variants != null &&
                    this.Variants.SequenceEqual(input.Variants)
                ) && 
                (
                    this.SimilarityToLastVersion == input.SimilarityToLastVersion ||
                    (this.SimilarityToLastVersion != null &&
                    this.SimilarityToLastVersion.Equals(input.SimilarityToLastVersion))
                ) && 
                (
                    this.WasInvalidatedBy == input.WasInvalidatedBy ||
                    (this.WasInvalidatedBy != null &&
                    this.WasInvalidatedBy.Equals(input.WasInvalidatedBy))
                ) && 
                (
                    this.HashParameters == input.HashParameters ||
                    (this.HashParameters != null &&
                    this.HashParameters.Equals(input.HashParameters))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.GeneratedAt != null)
                {
                    hashCode = (hashCode * 59) + this.GeneratedAt.GetHashCode();
                }
                if (this.WasRevisionOf != null)
                {
                    hashCode = (hashCode * 59) + this.WasRevisionOf.GetHashCode();
                }
                if (this.Variants != null)
                {
                    hashCode = (hashCode * 59) + this.Variants.GetHashCode();
                }
                if (this.SimilarityToLastVersion != null)
                {
                    hashCode = (hashCode * 59) + this.SimilarityToLastVersion.GetHashCode();
                }
                if (this.WasInvalidatedBy != null)
                {
                    hashCode = (hashCode * 59) + this.WasInvalidatedBy.GetHashCode();
                }
                if (this.HashParameters != null)
                {
                    hashCode = (hashCode * 59) + this.HashParameters.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
