/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the content page details for a resource.
    /// </summary>
    [DataContract(Name = "ResourceContentPageDto")]
    public partial class ResourceContentPageDto : IEquatable<ResourceContentPageDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceContentPageDto" /> class.
        /// </summary>
        /// <param name="varReadOnly">Indicates whether the resource is read-only..</param>
        /// <param name="metadataView">metadataView.</param>
        /// <param name="entriesView">entriesView.</param>
        public ResourceContentPageDto(bool varReadOnly = default(bool), ResourceContentPageMetadataViewDto metadataView = default(ResourceContentPageMetadataViewDto), ResourceContentPageEntriesViewDto entriesView = default(ResourceContentPageEntriesViewDto))
        {
            this.VarReadOnly = varReadOnly;
            this.MetadataView = metadataView;
            this.EntriesView = entriesView;
        }

        /// <summary>
        /// Indicates whether the resource is read-only.
        /// </summary>
        /// <value>Indicates whether the resource is read-only.</value>
        [DataMember(Name = "readOnly", EmitDefaultValue = true)]
        public bool VarReadOnly { get; set; }

        /// <summary>
        /// Gets or Sets MetadataView
        /// </summary>
        [DataMember(Name = "metadataView", EmitDefaultValue = false)]
        public ResourceContentPageMetadataViewDto MetadataView { get; set; }

        /// <summary>
        /// Gets or Sets EntriesView
        /// </summary>
        [DataMember(Name = "entriesView", EmitDefaultValue = false)]
        public ResourceContentPageEntriesViewDto EntriesView { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceContentPageDto {\n");
            sb.Append("  VarReadOnly: ").Append(VarReadOnly).Append("\n");
            sb.Append("  MetadataView: ").Append(MetadataView).Append("\n");
            sb.Append("  EntriesView: ").Append(EntriesView).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ResourceContentPageDto);
        }

        /// <summary>
        /// Returns true if ResourceContentPageDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ResourceContentPageDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ResourceContentPageDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.VarReadOnly == input.VarReadOnly ||
                    this.VarReadOnly.Equals(input.VarReadOnly)
                ) && 
                (
                    this.MetadataView == input.MetadataView ||
                    (this.MetadataView != null &&
                    this.MetadataView.Equals(input.MetadataView))
                ) && 
                (
                    this.EntriesView == input.EntriesView ||
                    (this.EntriesView != null &&
                    this.EntriesView.Equals(input.EntriesView))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                hashCode = (hashCode * 59) + this.VarReadOnly.GetHashCode();
                if (this.MetadataView != null)
                {
                    hashCode = (hashCode * 59) + this.MetadataView.GetHashCode();
                }
                if (this.EntriesView != null)
                {
                    hashCode = (hashCode * 59) + this.EntriesView.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
